Table of Contents

## Name

XSetLineAttributes, XSetDashes - GC convenience routines

## Syntax

int XSetLineAttributes(Display *display, GC gc, unsigned
  int line_width, int line_style, int cap_style, int join_style);
int XSetDashes(Display *display, GC gc, int
  dash_offset, char dash_list[], int n);

## Arguments

Specifies the line-style and cap-style you want to set for the specified GC. You can pass CapNotLast, CapButt, CapRound, or CapProjecting.

Specifies the dash-list for the dashed line-style you want to set for the specified GC.

Specifies the phase of the pattern for the dashed line-style you want to set for the specified GC.

Specifies the connection to the X server.

Specifies the GC.

Specifies the line join-style you want to set for the specified GC. You can pass JoinMiter, JoinRound, or JoinBevel.

Specifies the line-style you want to set for the specified GC. You can pass LineSolid, LineOnOffDash, or LineDoubleDash.

Specifies the line-width you want to set for the specified GC.

Specifies the number of elements in dash_list.

## Description

The XSetLineAttributes function sets the line drawing components in the specified GC.

XSetLineAttributes can generate BadAlloc, BadGC, and BadValue errors.

The XSetDashes function sets the dash-offset and dash-list attributes for dashed line styles in the specified GC. There must be at least one element in the specified dash_list, or a BadValue error results. The initial and alternating elements (second, fourth, and so on) of the dash_list are the even dashes, and the others are the odd dashes. Each element specifies a dash length in pixels. All of the elements must be nonzero, or a BadValue error results. Specifying an odd-length list is equivalent to specifying the same list concatenated with itself to produce an even-length list.

The dash-offset defines the phase of the pattern, specifying how many pixels into the dash-list the pattern should actually begin in any single graphics request. Dashing is continuous through path elements combined with a join-style but is reset to the dash-offset between each sequence of joined lines.

The unit of measure for dashes is the same for the ordinary coordinate system. Ideally, a dash length is measured along the slope of the line, but implementations are only required to match this ideal for horizontal and vertical lines. Failing the ideal semantics, it is suggested that the length be measured along the major axis of the line. The major axis is defined as the x axis for lines drawn at an angle of between -45 and +45 degrees or between 135 and 225 degrees from the x axis. For all other lines, the major axis is the y axis.

XSetDashes can generate BadAlloc, BadGC, and BadValue errors.

## Diagnostics

BadAlloc
  The server failed to allocate the requested resource or server memory.
BadGC
  A value for a GContext argument does not name a defined GContext.
BadValue
  Some numeric value falls outside the range of values accepted by the request. Unless a specific range is specified for an argument, the full range defined by the argument's type is accepted. Any argument defined as a set of alternatives can generate this error.

## See Also

XCreateGC(3X11) , XQueryBestSize(3X11) , XSetArcMode(3X11) , XSetClipOrigin(3X11) , XSetFillStyle(3X11) , XSetFont(3X11) , XSetState(3X11) , XSetTile(3X11)
Xlib - C Language X Interface

Table of Contents

- Name
- Syntax
- Arguments
- Description
- Diagnostics
- See Also